<!doctype html>
<html>
  <head>
    <title>Swagger User Profiling System</title>
    <style type="text/css">
      body {
	font-family: Trebuchet MS, sans-serif;
	font-size: 15px;
	color: #444;
	margin-right: 24px;
}

h1	{
	font-size: 25px;
}
h2	{
	font-size: 20px;
}
h3	{
	font-size: 16px;
	font-weight: bold;
}
hr	{
	height: 1px;
	border: 0;
	color: #ddd;
	background-color: #ddd;
}

.app-desc {
  clear: both;
  margin-left: 20px;
}
.param-name {
  width: 100%;
}
.license-info {
  margin-left: 20px;
}

.license-url {
  margin-left: 20px;
}

.model {
  margin: 0 0 0px 20px;
}

.method {
  margin-left: 20px;
}

.method-notes	{
	margin: 10px 0 20px 0;
	font-size: 90%;
	color: #555;
}

pre {
  padding: 10px;
  margin-bottom: 2px;
}

.http-method {
 text-transform: uppercase;
}

pre.get {
  background-color: #0f6ab4;
}

pre.post {
  background-color: #10a54a;
}

pre.put {
  background-color: #c5862b;
}

pre.delete {
  background-color: #a41e22;
}

.huge	{
	color: #fff;
}

pre.example {
  background-color: #f3f3f3;
  padding: 10px;
  border: 1px solid #ddd;
}

code {
  white-space: pre;
}

.nickname {
  font-weight: bold;
}

.method-path {
  font-size: 1.5em;
  background-color: #0f6ab4;
}

.up {
  float:right;
}

.parameter {
  width: 500px;
}

.param {
  width: 500px;
  padding: 10px 0 0 20px;
  font-weight: bold;
}

.param-desc {
  width: 700px;
  padding: 0 0 0 20px;
  color: #777;
}

.param-type {
  font-style: italic;
}

.param-enum-header {
width: 700px;
padding: 0 0 0 60px;
color: #777;
font-weight: bold;
}

.param-enum {
width: 700px;
padding: 0 0 0 80px;
color: #777;
font-style: italic;
}

.field-label {
  padding: 0;
  margin: 0;
  clear: both;
}

.field-items	{
	padding: 0 0 15px 0;
	margin-bottom: 15px;
}

.return-type {
  clear: both;
  padding-bottom: 10px;
}

.param-header {
  font-weight: bold;
}

.method-tags {
  text-align: right;
}

.method-tag {
  background: none repeat scroll 0% 0% #24A600;
  border-radius: 3px;
  padding: 2px 10px;
  margin: 2px;
  color: #FFF;
  display: inline-block;
  text-decoration: none;
}

    </style>
  </head>
  <body>
  <h1>Swagger User Profiling System</h1>
    <div class="app-desc">This is a first draft of the swagger implementation of the User Profiling System API.</div>
    <div class="app-desc">More information: <a href="https://helloreverb.com">https://helloreverb.com</a></div>
    <div class="app-desc">Contact Info: <a href="david.friede@neclab.eu">david.friede@neclab.eu</a></div>
    <div class="app-desc">Version: 0.1.0</div>
    <div class="app-desc">BasePath:/</div>
    <div class="license-info">All rights reserved</div>
    <div class="license-url">http://apache.org/licenses/LICENSE-2.0.html</div>
  <h2>Access</h2>

  <h2><a name="__Methods">Methods</a></h2>
  [ Jump to <a href="#__Models">Models</a> ]

  <h3>Table of Contents </h3>
  <div class="method-summary"></div>
  <h4><a href="#Categories">Categories</a></h4>
  <ul>
  <li><a href="#categoriesUserIDDelete"><code><span class="http-method">delete</span> /categories/{userID}</code></a></li>
  <li><a href="#categoriesUserIDGet"><code><span class="http-method">get</span> /categories/{userID}</code></a></li>
  <li><a href="#categoriesUserIDPut"><code><span class="http-method">put</span> /categories/{userID}</code></a></li>
  </ul>
  <h4><a href="#Ignored">Ignored</a></h4>
  <ul>
  <li><a href="#ignoredUserIDGet"><code><span class="http-method">get</span> /ignored/{userID}</code></a></li>
  <li><a href="#ignoredUserIDPut"><code><span class="http-method">put</span> /ignored/{userID}</code></a></li>
  </ul>
  <h4><a href="#Profile">Profile</a></h4>
  <ul>
  <li><a href="#profileUserIDDelete"><code><span class="http-method">delete</span> /profile/{userID}</code></a></li>
  <li><a href="#profileUserIDGet"><code><span class="http-method">get</span> /profile/{userID}</code></a></li>
  </ul>
  <h4><a href="#Train">Train</a></h4>
  <ul>
  <li><a href="#trainUserIDGet"><code><span class="http-method">get</span> /train/{userID}</code></a></li>
  </ul>

  <h1><a name="Categories">Categories</a></h1>
  <div class="method"><a name="categoriesUserIDDelete"/>
    <div class="method-path">
    <a class="up" href="#__Methods">Up</a>
    <pre class="delete"><code class="huge"><span class="http-method">delete</span> /categories/{userID}</code></pre></div>
    <div class="method-summary">Fully delete the profile categories / reset them to zero (<span class="nickname">categoriesUserIDDelete</span>)</div>
    <div class="method-notes"></div>

    <h3 class="field-label">Path parameters</h3>
    <div class="field-items">
      <div class="param">userID (required)</div>

      <div class="param-desc"><span class="param-type">Path Parameter</span> &mdash; ID of profile to delete format: int64</div>
    </div>  <!-- field-items -->







    <!--Todo: process Response Object and its headers, schema, examples -->


    <h3 class="field-label">Produces</h3>
    This API call produces the following media types according to the <span class="header">Accept</span> request header;
    the media type will be conveyed by the <span class="header">Content-Type</span> response header.
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Responses</h3>
    <h4 class="field-label">200</h4>
    Delete user profile
        <a href="#"></a>
    <h4 class="field-label">404</h4>
    Profile missing
        <a href="#"></a>
  </div> <!-- method -->
  <hr/>
  <div class="method"><a name="categoriesUserIDGet"/>
    <div class="method-path">
    <a class="up" href="#__Methods">Up</a>
    <pre class="get"><code class="huge"><span class="http-method">get</span> /categories/{userID}</code></pre></div>
    <div class="method-summary">Get a summary of the profiled categories of a specific user (<span class="nickname">categoriesUserIDGet</span>)</div>
    <div class="method-notes"></div>

    <h3 class="field-label">Path parameters</h3>
    <div class="field-items">
      <div class="param">userID (required)</div>

      <div class="param-desc"><span class="param-type">Path Parameter</span> &mdash; ID of profile to return categories format: int64</div>
    </div>  <!-- field-items -->







    <!--Todo: process Response Object and its headers, schema, examples -->


    <h3 class="field-label">Produces</h3>
    This API call produces the following media types according to the <span class="header">Accept</span> request header;
    the media type will be conveyed by the <span class="header">Content-Type</span> response header.
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Responses</h3>
    <h4 class="field-label">200</h4>
    Get user profile categories
        <a href="#"></a>
    <h4 class="field-label">404</h4>
    Profile missing
        <a href="#"></a>
  </div> <!-- method -->
  <hr/>
  <div class="method"><a name="categoriesUserIDPut"/>
    <div class="method-path">
    <a class="up" href="#__Methods">Up</a>
    <pre class="put"><code class="huge"><span class="http-method">put</span> /categories/{userID}</code></pre></div>
    <div class="method-summary">Set user specific categories as the profile categories. These categories are added to the blacklist of categories untouched by the algorithm (<span class="nickname">categoriesUserIDPut</span>)</div>
    <div class="method-notes"></div>

    <h3 class="field-label">Path parameters</h3>
    <div class="field-items">
      <div class="param">userID (required)</div>

      <div class="param-desc"><span class="param-type">Path Parameter</span> &mdash; ID of profile to delete format: int64</div>
    </div>  <!-- field-items -->

    <h3 class="field-label">Consumes</h3>
    This API call consumes the following media types via the <span class="header">Content-Type</span> request header:
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Request body</h3>
    <div class="field-items">
      <div class="param">user_categories  (optional)</div>

      <div class="param-desc"><span class="param-type">Body Parameter</span> &mdash; The user specific categories to set </div>

    </div>  <!-- field-items -->





    <!--Todo: process Response Object and its headers, schema, examples -->


    <h3 class="field-label">Produces</h3>
    This API call produces the following media types according to the <span class="header">Accept</span> request header;
    the media type will be conveyed by the <span class="header">Content-Type</span> response header.
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Responses</h3>
    <h4 class="field-label">200</h4>
    Set user specific categories
        <a href="#"></a>
    <h4 class="field-label">404</h4>
    Profile missing
        <a href="#"></a>
  </div> <!-- method -->
  <hr/>
  <h1><a name="Ignored">Ignored</a></h1>
  <div class="method"><a name="ignoredUserIDGet"/>
    <div class="method-path">
    <a class="up" href="#__Methods">Up</a>
    <pre class="get"><code class="huge"><span class="http-method">get</span> /ignored/{userID}</code></pre></div>
    <div class="method-summary">Get a summary of the blacklisted categories of a specific user. The blacklisted categories are the ones staying untouched by the algorithm (<span class="nickname">ignoredUserIDGet</span>)</div>
    <div class="method-notes"></div>

    <h3 class="field-label">Path parameters</h3>
    <div class="field-items">
      <div class="param">userID (required)</div>

      <div class="param-desc"><span class="param-type">Path Parameter</span> &mdash; ID of profile to return categories format: int64</div>
    </div>  <!-- field-items -->







    <!--Todo: process Response Object and its headers, schema, examples -->


    <h3 class="field-label">Produces</h3>
    This API call produces the following media types according to the <span class="header">Accept</span> request header;
    the media type will be conveyed by the <span class="header">Content-Type</span> response header.
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Responses</h3>
    <h4 class="field-label">200</h4>
    Get set of blacklisted user profile categories
        <a href="#"></a>
    <h4 class="field-label">404</h4>
    Profile missing
        <a href="#"></a>
  </div> <!-- method -->
  <hr/>
  <div class="method"><a name="ignoredUserIDPut"/>
    <div class="method-path">
    <a class="up" href="#__Methods">Up</a>
    <pre class="put"><code class="huge"><span class="http-method">put</span> /ignored/{userID}</code></pre></div>
    <div class="method-summary">Set a user specific choice of categories that always stay untouched by the algorithm. (<span class="nickname">ignoredUserIDPut</span>)</div>
    <div class="method-notes"></div>

    <h3 class="field-label">Path parameters</h3>
    <div class="field-items">
      <div class="param">userID (required)</div>

      <div class="param-desc"><span class="param-type">Path Parameter</span> &mdash; ID of profile to delete format: int64</div>
    </div>  <!-- field-items -->

    <h3 class="field-label">Consumes</h3>
    This API call consumes the following media types via the <span class="header">Content-Type</span> request header:
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Request body</h3>
    <div class="field-items">
      <div class="param">user_ignored_categories  (optional)</div>

      <div class="param-desc"><span class="param-type">Body Parameter</span> &mdash; The user specific choice of categories to be ignored by the algorithm </div>

    </div>  <!-- field-items -->





    <!--Todo: process Response Object and its headers, schema, examples -->


    <h3 class="field-label">Produces</h3>
    This API call produces the following media types according to the <span class="header">Accept</span> request header;
    the media type will be conveyed by the <span class="header">Content-Type</span> response header.
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Responses</h3>
    <h4 class="field-label">200</h4>
    Set user specific categories
        <a href="#"></a>
    <h4 class="field-label">404</h4>
    Profile missing
        <a href="#"></a>
  </div> <!-- method -->
  <hr/>
  <h1><a name="Profile">Profile</a></h1>
  <div class="method"><a name="profileUserIDDelete"/>
    <div class="method-path">
    <a class="up" href="#__Methods">Up</a>
    <pre class="delete"><code class="huge"><span class="http-method">delete</span> /profile/{userID}</code></pre></div>
    <div class="method-summary">Fully delete the profile (<span class="nickname">profileUserIDDelete</span>)</div>
    <div class="method-notes"></div>

    <h3 class="field-label">Path parameters</h3>
    <div class="field-items">
      <div class="param">userID (required)</div>

      <div class="param-desc"><span class="param-type">Path Parameter</span> &mdash; ID of profile to delete format: int64</div>
    </div>  <!-- field-items -->







    <!--Todo: process Response Object and its headers, schema, examples -->


    <h3 class="field-label">Produces</h3>
    This API call produces the following media types according to the <span class="header">Accept</span> request header;
    the media type will be conveyed by the <span class="header">Content-Type</span> response header.
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Responses</h3>
    <h4 class="field-label">200</h4>
    Delete user profile
        <a href="#"></a>
    <h4 class="field-label">404</h4>
    Profile missing
        <a href="#"></a>
  </div> <!-- method -->
  <hr/>
  <div class="method"><a name="profileUserIDGet"/>
    <div class="method-path">
    <a class="up" href="#__Methods">Up</a>
    <pre class="get"><code class="huge"><span class="http-method">get</span> /profile/{userID}</code></pre></div>
    <div class="method-summary">Get some information, e.g., categories of a specific user (<span class="nickname">profileUserIDGet</span>)</div>
    <div class="method-notes"></div>

    <h3 class="field-label">Path parameters</h3>
    <div class="field-items">
      <div class="param">userID (required)</div>

      <div class="param-desc"><span class="param-type">Path Parameter</span> &mdash; ID of profile to return format: int64</div>
    </div>  <!-- field-items -->







    <!--Todo: process Response Object and its headers, schema, examples -->


    <h3 class="field-label">Produces</h3>
    This API call produces the following media types according to the <span class="header">Accept</span> request header;
    the media type will be conveyed by the <span class="header">Content-Type</span> response header.
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Responses</h3>
    <h4 class="field-label">200</h4>
    Get user profile
        <a href="#"></a>
    <h4 class="field-label">404</h4>
    Profile missing
        <a href="#"></a>
  </div> <!-- method -->
  <hr/>
  <h1><a name="Train">Train</a></h1>
  <div class="method"><a name="trainUserIDGet"/>
    <div class="method-path">
    <a class="up" href="#__Methods">Up</a>
    <pre class="get"><code class="huge"><span class="http-method">get</span> /train/{userID}</code></pre></div>
    <div class="method-summary">Connect to net2vec, run the algorithm on the specific user but ignore the blacklisted categories. Get the profiled categories. (<span class="nickname">trainUserIDGet</span>)</div>
    <div class="method-notes"></div>

    <h3 class="field-label">Path parameters</h3>
    <div class="field-items">
      <div class="param">userID (required)</div>

      <div class="param-desc"><span class="param-type">Path Parameter</span> &mdash; ID of profile to return categories format: int64</div>
    </div>  <!-- field-items -->







    <!--Todo: process Response Object and its headers, schema, examples -->


    <h3 class="field-label">Produces</h3>
    This API call produces the following media types according to the <span class="header">Accept</span> request header;
    the media type will be conveyed by the <span class="header">Content-Type</span> response header.
    <ul>
      <li><code>application/json</code></li>
    </ul>

    <h3 class="field-label">Responses</h3>
    <h4 class="field-label">200</h4>
    Get set of blacklisted user profile categories
        <a href="#"></a>
    <h4 class="field-label">401</h4>
    Dataset of visited hosts missing
        <a href="#"></a>
    <h4 class="field-label">404</h4>
    Profile missing
        <a href="#"></a>
  </div> <!-- method -->
  <hr/>

  <h2><a name="__Models">Models</a></h2>
  [ Jump to <a href="#__Methods">Methods</a> ]

  <h3>Table of Contents</h3>
  <ol>
    <li><a href="#Profile"><code>Profile</code> - </a></li>
  </ol>

  <div class="model">
    <h3><a name="Profile"><code>Profile</code> - </a> <a class="up" href="#__Models">Up</a></h3>
    <div class='model-description'></div>
    <div class="field-items">
      <div class="param">id (optional)</div><div class="param-desc"><span class="param-type"><a href="#long">Long</a></span>  format: int64</div>
<div class="param">user_id (optional)</div><div class="param-desc"><span class="param-type"><a href="#string">String</a></span>  format: string</div>
<div class="param">host_visited (optional)</div><div class="param-desc"><span class="param-type"><a href="#string">String</a></span>  format: string</div>
<div class="param">last_profiled (optional)</div><div class="param-desc"><span class="param-type"><a href="#DateTime">Date</a></span>  format: date-time</div>
<div class="param">ignored_categories (optional)</div><div class="param-desc"><span class="param-type"><a href="#string">String</a></span>  format: string</div>
<div class="param">cat_0 (optional)</div><div class="param-desc"><span class="param-type"><a href="#number">BigDecimal</a></span>  </div>
<div class="param">cat_1 (optional)</div><div class="param-desc"><span class="param-type"><a href="#number">BigDecimal</a></span>  </div>
<div class="param">cat_2 (optional)</div><div class="param-desc"><span class="param-type"><a href="#number">BigDecimal</a></span>  </div>
<div class="param">cat_3 (optional)</div><div class="param-desc"><span class="param-type"><a href="#number">BigDecimal</a></span>  </div>
<div class="param">cat_4 (optional)</div><div class="param-desc"><span class="param-type"><a href="#number">BigDecimal</a></span>  </div>
    </div>  <!-- field-items -->
  </div>
  </body>
</html>
